/*****************************************************************************
 * This is an illustration of vector iterators. Like pointers, iterators 
 * indicate a location. To get the value at the location, use the dereferencing
 * operator, '*' .
 ****************************************************************************/
#include <iostream>
#include <vector>

using std::cin; using std::cout;            
using std::endl;            
using std::vector;

void show_vec(const vector<int>& v);

int main()
{
	vector<int> V, div;
	int num;
	for(int i=1; i!=21; i++)
		V.push_back(i);//Load the vector with values 1-20
	cout<<"Enter an integer. The program will sort the values 1-20"
	       <<" into values that  divide that integer evenly and "
      	       <<"values that do not.\nYour integer :";
	cin>>num;
	vector<int>::size_type i=0;
	while(i!=V.size())
	{
		if(num%V[i]==0){
			div.push_back(V[i]);//Push the value into the divisor
					    //vector.
			V.erase(V.begin()+i);//Erase it from the original. The
					     //index i now denotes the next 
					     //value in V.
		}
		else
			++i;
	}
	cout<<"The values that divide "<<num<<" are\n";
	show_vec(div);
	cout<<endl<<"The values that do not divide "<<num<<" are\n";
	show_vec(V);

		
	
 	

	

	return 0;
			
}
void show_vec(const vector<int>& v)
{
	for(vector<int>::const_iterator iter=v.begin(); iter!=v.end();++iter)
		cout<<*iter<<" ";
	/* We need a const iterator here because we passed v by constant 
	 * reference.
	 */
	return;
}
	
